import sys
import shutil
import atexit
import tempfile
try:
    from launchpadlib.launchpad import Launchpad
except ImportError:
    print >> sys.stderr, "In order to use the Launchpad API you'll need " + \
        "to install https://help.launchpad.net/API/launchpadlib"


def no_credential():
    print >> sys.stderr, "Can't proceed without a Launchpad credential."
    sys.exit(1)


def get_launchpad(use_staging=False):
    cachedir = tempfile.mkdtemp()
    atexit.register(shutil.rmtree, cachedir)
    print >> sys.stderr, 'Logging in to Launchpad...'
    server = (lambda s: 'staging' if s else 'production')(use_staging)

    launchpad = Launchpad.login_anonymously('ubuntu_l10n_tools',
                                     server,
                                     cachedir,
#                                     credential_save_failed=no_credential)
                                    )

    return launchpad


def get_releases(launchpad):
    print >> sys.stderr, 'Getting Ubuntu releases from Launchpad...'
    releases = launchpad.distributions["ubuntu"].series

    return filter(lambda a: a.active, releases)


def get_languages(launchpad):
    print >> sys.stderr, 'Getting languages from Launchpad...'
    lp_languages = launchpad.languages

    return [language for language in lp_languages if language.visible]
