import datetime
import urllib2
import codecs
import time
import csv

def get_http_timestamp(url):
    try:
        sock = urllib2.urlopen(url)
    except:
        return None

    timestamp_lm = None
    if sock.info()["Last-Modified"]:
        lm_string = sock.info()["Last-Modified"]
        sock.close()
        if lm_string:
            timestamp_lm = time.mktime(time.strptime(lm_string, "%a, %d %b %Y %H:%M:%S GMT"))
            datetime_lm = datetime.datetime.utcfromtimestamp(timestamp_lm)
            return datetime_lm
    return None

def utf_8_encoder(unicode_csv_data):
    for line in unicode_csv_data:
        yield line.encode('utf-8')

def unicode_csv_reader(unicode_csv_data, dialect=csv.excel, **kwargs):
    # csv.py doesn't do Unicode; encode temporarily as UTF-8:
    csv_reader = csv.reader(utf_8_encoder(unicode_csv_data), dialect=dialect, **kwargs)
    for row in filter(lambda a: a != [], csv_reader):
        # decode UTF-8 back to Unicode, cell by cell:
        yield [unicode(cell.strip(), 'utf-8') for cell in row]

def read_unicode_csv(data_file):
    content = codecs.open(data_file, encoding="utf-8", mode="r").read()
    data = map(lambda a: a.strip(), content.split("\n"))
    return [a for a in unicode_csv_reader(data)]
