from django.contrib import admin
from stats.models import (Language, UbuntuRelease, Timestamp, Template,
                          Translation,
                         )


class TimestampAdmin(admin.ModelAdmin):
    list_display = ('release', 'language', 'timestamp', )
    list_filter = ['release', 'language']


class LanguageAdmin(admin.ModelAdmin):
    list_display = ('name', )
    search_fields = ['name']


class UbuntuReleaseAdmin(admin.ModelAdmin):
    list_display = ('name', )


class TemplateAdmin(admin.ModelAdmin):
    list_display = ('release', 'template_name', 'sourcepackage',
                    'translation_domain', 'total', 'priority')
    list_filter = ['release', 'enabled', 'defaultinstall', 'whitelisted',
                   'blacklisted', ]
    search_fields = ['template_name']


class TranslationAdmin(admin.ModelAdmin):
    list_display = ('language', 'release', 'template', 'translated', )
    list_filter = ['release', 'language']

admin.site.register(Language, LanguageAdmin)
admin.site.register(UbuntuRelease, UbuntuReleaseAdmin)
admin.site.register(Timestamp, TimestampAdmin)
admin.site.register(Template, TemplateAdmin)
admin.site.register(Translation, TranslationAdmin)
