/*
 * Author: David Planella <david.planella@ubuntu.com>
 *
 * Copyright (c) 2010, 2011, 2012 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3, as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranties of MERCHANTABILITY,
 * SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

google.load("visualization", "1", {
    packages: ["table", "intensitymap"]
});

function drawTable(data, translated_count) {

    var language_table_data = new google.visualization.DataTable(
        data, 0.6);

    var language_table = new google.visualization.Table(
        document.getElementById('lang_stats_table'));

    /* Format the data column containing the translation percentage
       value: show no decimal digits */
    var nr_formatter = new google.visualization.NumberFormat({
        fractionDigits: 0,
        suffix: ' %'
    });
    nr_formatter.format(language_table_data, 1);

    /* Format the data column containing the translation percentage
       value: show a green bar indicating the level of coverage */
    var bar_formatter = new google.visualization.BarFormat({
        min: 0,
        max: 100,
        width: 100,
        colorPositive: 'green'
    });
    bar_formatter.format(language_table_data, 1);

    /* Draw the statistics table */
    language_table.draw(language_table_data, {
        allowHtml: true,
        showRowNumber: true,
        sortColumn: 1,
        sortAscending: false,
        page: 'enable',
        cssClassNames: {headerRow: 'table_header',
                        hoverTableRow: 'row_hover',
                        selectedTableRow: 'row_selected',
                        headerCell: 'table_header_cell_left'},
        pageSize: translated_count,
    });

}

function drawMap(json_data){
    $.getJSON(json_data,
    function(data){
        var map_data = new google.visualization.DataTable(data, 0.6);

        var map = new google.visualization.IntensityMap(
            document.getElementById('stats_map'));

        map.draw(map_data, {
            colors: ['#DD4814'],
            height: 220,
            width: 420
        });
    });
}

function OnLoad() {
    drawTable(lang_data, translated_count);
    drawMap(country_data);
}

google.setOnLoadCallback(
    //function(){ drawTable(data);}
    OnLoad
);
